
public class Adder implements Prettifier {

	/**
	 * Uebergebene Parameter: comment: ist einzufuegender Text position: an
	 * welcher Position sequence: Zeile, die Zeichenfolge(=sequence) beinhaltet,
	 * ist Position vor/nach der Kommentar eingefuegt werden soll Invarianten:
	 * Variablen nicht NULL sein
	 */

	private String comment;
	final private PrettyPos position;
	private String sequence;

	public Adder(String comment, PrettyPos position, String sequence) {

		this.comment = comment;
		this.position = position;
		this.sequence = sequence;

	}

	/**
	 * Vom Interface verlangte Methode uebergibt Programm VB: prog != NULL NB:
	 * Methode retourniert veraendertes Programm wieder mit neu hinzugefügtem
	 * Kommentar
	 */
	public String pretty(String prog) {

		/**
		 * Beginn des Programmes
		 */
		if (position.equals(PrettyPos.BEGIN)) {

			prog = "/* " + comment + " */" + "\n" + prog;

		}

		/**
		 * Ende des Programmes
		 */
		else if (position.equals(PrettyPos.END)) {
			prog = prog + "/* " + comment + " */";
		}

		/**
		 * Vor bestimmter Zeile
		 */
		else if (position.equals(PrettyPos.BEFORE)) {

			String[] progAsArray = prog.split("\\n");

			for (int i = 0; i < progAsArray.length; i++) {

				String currentRow = progAsArray[i];

				if (currentRow.contains(sequence) && !(currentRow.contains("/*")) && !(currentRow.contains("*/"))
						&& !(currentRow.contains("//")) && !(currentRow.contains("*"))) {

					progAsArray[i] = "/* " + comment + " */" + "\n" + progAsArray[i] + "\n";

				} else {
					progAsArray[i] = progAsArray[i] + "\n";
				}

			}

			/**
			 * Convert from Array to String
			 */
			// prog = Arrays.toString(progAsArray);
			String save = "";
			for (String current : progAsArray) {
				save = save + current;
			}

			prog = save;

		} // if-Ende

		/**
		 * Nach bestimmter Zeile
		 */
		else if (position.equals(PrettyPos.AFTER)) {

			String[] progAsArray = prog.split("\\n");

			for (int i = 0; i < progAsArray.length; i++) {

				String currentRow = progAsArray[i];

				if (currentRow.contains(sequence) && !(currentRow.contains("/*")) && !(currentRow.contains("*/"))
						&& !(currentRow.contains("//")) && !(currentRow.contains("*"))) {

					progAsArray[i] = progAsArray[i] + "\n" + "/* " + comment + " */" + "\n";

				} else {
					progAsArray[i] = progAsArray[i] + "\n";
				}

			}

			/**
			 * Convert from Array to String
			 */
			// prog = Arrays.toString(progAsArray);
			String save = "";
			for (String current : progAsArray) {
				save = save + current;
			}

			prog = save;

		} // if-Ende

		return prog;
	} // Methode Ende

	/**
	 * VB: text != NULL NB: Aendert einzufuegenden Kommentar nachtraeglich
	 */
	public void changeComment(String text) {
		this.comment = text;
	}

	// Inhalt
}
