/**
 * 
 * @author David Unterweger 1127540
 * 
 */
public class DeepPurifier extends AbsPurifier {

	// Der Einfachheit halber beschreibt dif falls negativ, dass die letzten
	// |dif| Zeichen aus indent entfern werden (ungeachtet dessen ob es sich um
	// Leerzeichen oder Tabulatoren handelt), falls dif Positiv werden einfach
	// dif viele Leerzeichen an indent angehaengt
	private int dif;
	AltPurifierType type;

	public DeepPurifier(AltPurifierType type, int dif) {
		this.type = type;
		this.dif = dif;
	}

	@Override
	// VB:
	// s muss Zeichen enthalten die kein Whitespace sind, s darf den substring
	// "*/" nicht enthalten; indent != null, indent
	// enthaelt keine Zeichen außer ' ' und '\t'
	//
	// NB:
	// return ist ein gueltiger JavaKommentar, wobei die Einrueckung des
	// Kommentars indent gefolgt von dif Leerzeichen entspricht (falls dif
	// positiv) andernfalls ist die Einrueckung indent ohne die letzten |dif|
	// Zeichen
	protected String wrapToComment(String s, String indent) {

		indent = getDifIndent(indent);

		if (this.type == AltPurifierType.LINE) {
			return wrapToLine(s, indent);
		} else if (type == AltPurifierType.MULTILINE) {
			return wrapToMultiLine(s, indent);
		} else {
			return wrapToLineMultiLine(s, indent);
		}
	}

	// VB: indent != null
	//
	// NB: result ist indent um |dif| Zeichen verkuerzt, falls dif negativ;
	// andernfalls ist result indent um dif Leerzeichen verlaengert
	private String getDifIndent(String indent) {
		if (this.dif < 0) {
			if (Math.abs(dif) < indent.length()) {
				return indent.substring(0, indent.length() + dif);
			} else {
				return "";
			}
		} else if (this.dif > 0) {
			return addSpace(indent, dif);
		} else {
			return indent;
		}
	}

	// VB: i >= 0
	//
	// NB: result ist s verlaengert um i Leerzeichen
	private String addSpace(String s, int i) {
		for (int j = 0; j < i; j++) {
			s += " ";
		}
		return s;
	}

	// NB: this.dif ist nun dif
	public void setDif(int dif) {
		this.dif = dif;
	}
}
