public class Test {

	/*
	 * 
	 * Gefundene Untertypbeziehungen:
	 * 
	 * > Composer steht in keiner Untertypbeziehung zu den restlichen Klassen
	 * (Ausser Prettifier natuerlich)
	 * 
	 * > Adder ist Obertyp von Copyrighter
	 * 
	 * >Eraser ist Obertyp von Stripper
	 * 
	 * >Purifier ist Untertyp von AltPurifier, da er einen Spezialfall von
	 * AltPurifier beschreibt
	 * 
	 * >Bei DeepPurifier taten wir uns etwas schwer, einerseits beschreibt die
	 * Funktionalitaet im Prinzip dasselbe wie AltPurifier nur allgemeiner, was
	 * darauf hindeuten koennte, dass DeepPurifier Obertyp von AltPurifier ist,
	 * allerdings steht in DeepPurifier eine Methode, welche die Einrueckung
	 * veraendern kann, welche in AltPurifier nichts zu suchen hat. Somit ist
	 * DeepPurifier kein Obertyp von AltPurifier. Umgekehrt funktionierts auch
	 * nicht, da die Nachbedingung von wrapToComment() in AltPurifier
	 * "...wobei vor jeder Zeile indent angehaengt wird, was der Einrueckung entspricht"
	 * in DeepPurifier verletzt waere. Somit besteht zwischen beiden Klassen
	 * keine UntertypBeziehung und DeepPurifier ist direkter Untertyp von
	 * AbsPurifier
	 */

	private final String BAR = "================================\n================================\n";
	private final String testProg1 = "/* Kommentar am Anfang  in Sternderl-Notation */\n" + "public class test {\n"
			+ "   /* Kommentar vorher in Sternderl-Notation */ \n" + "   public void func1() {\n"
			+ "   /* Kommentar nachher in Sternderl-Notation */ \n" + "      callFunc();\n" + "   }\n"
			+ "   /* Kommentar vorher in Sternderl-Notation */ \n" + "   private func2() {\n"
			+ "   /* Kommentar nachher in Sternderl-Notation */ \n" + "      callFunc2();\n" + "   }\n" + "}\n"
			+ "/* Kommentar am Ende in Sternderl-Notation */\n";

	private final String testProg2 = "// Kommentar am Anfang  in Doppel-slash-Notation\n" + "public class test {\n"
			+ "   // Kommentar vorher in Doppel-slash-Notation \n" + "   public void func1() {\n"
			+ "   // Kommentar nachher in Doppel-slash-Notation \n" + "      callFunc();\n" + "   }\n"
			+ "   // Kommentar vorher in Doppel-slash-Notation \n" + "   private func2() {\n"
			+ "   // Kommentar nachher in Doppel-slash-Notation \n" + "      callFunc2();\n" + "   }\n" + "}\n"
			+ "// Kommentar am Ende in Doppel-slash-Notation\n";

	private final String testProg3 = "/* Kommentar am Anfang  in Sternderl-Notation \n" + "über mehrere Zeilen \n"
			+ "und noch eine... */\n" + "public class test {\n" + "   /* Kommentar vorher in Sternderl-Notation  \n"
			+ "über mehrere Zeilen \n" + "und noch eine... */\n" + "   public void func1() {\n"
			+ "   /* Kommentar nachherin Sternderl-Notation  \n" + "über mehrere Zeilen \n" + "und noch eine... */\n"
			+ "      callFunc();\n" + "   }\n" + "   /* Kommentar vorher in Sternderl-Notation  \n"
			+ "über mehrere Zeilen \n" + "und noch eine... */\n" + "   private func2() {\n"
			+ "   /* Kommentar nachher in Sternderl-Notation \n" + "über mehrere Zeilen \n" + "und noch eine... */\n"
			+ "      callFunc2();\n" + "   }\n" + "}\n" + "/* Kommentar am Ende in Sternderl-Notation\n"
			+ "über mehrere Zeilen \n" + "und noch eine... */\n";

	private final String testProg4 = "/**/\n//\n/* */\n// Mehrzeiliger Kommentar in Doppel-\n//slash-Notation\n"
			+ "public class test {\n"
			+ "   //Einzeiliger Kommentar\n"
			+ "   public void func1() {\n"
			+ "      callFunc();\n"
			+ "   }\n"
			+ "   /* Kommentar vorher \n \nin Sternderl-Notation  \n"
			+ "über mehrere Zeilen \n"
			+ "und noch eine... */\n"
			+ "   //Gefolgt von einem Kommentar\n"
			+ "   private func2() {\n"
			+ "/* Kommentar am Beginn der Codezeile*/      callFunc2();/*1. Kommentar zwischen zwei Codefragmenten in einer Zeile *//*2. KOmmentar zwischen zwei Codefragmenten */      callFunc2(); //Kommentar am Ende einer CodeZeile 	\n"
			+ "   }\n" + "}\n" + "/* Kommentar am Ende in Sternderl-Notation\n" + "über mehrere Zeilen \n"
			+ "und noch eine... */\n";

	public Test() {

		System.out.println("Die Programme vor der Verschönerung: ");
		System.out.println("====================================");

		System.out.println(testProg1);
		System.out.println(testProg2);
		System.out.println(testProg3);
		System.out.println(testProg4);

	}

	public void run() {

		Copyrighter a = new Copyrighter();
		a.addAuthor("aa");

		System.out.println(a.pretty(testProg1));

		int i = 0;
		Composer c = new Composer();
		Copyrighter copyrighter = new Copyrighter();
		copyrighter.addAuthor("Hans");
		copyrighter.addAuthor("Susi");
		copyrighter.setDate();
		Adder a1 = copyrighter;
		c.addPrettifier(++i, a1);
		Adder a2 = new Adder("Ein neuer Kommentar nach jedem Block:)", PrettyPos.AFTER, "}");
		c.addPrettifier(++i, a2);
		System.out.println("TestProg1 mit Copyrightinfo und einem Kommentar nach jedem block\n-------------\n"
				+ c.pretty(testProg1));

		Eraser e1 = new Stripper();
		c.addPrettifier(++i, e1);
		System.out
				.println("TestProg2 nach hinzufügen von Copyrightinfo und Kommentaren mit abschließendem Löschen von allen Kommentaren\n---------------\n"
						+ c.pretty(testProg2));
		c.removePrettifier(i--);
		c.removePrettifier(i--);
		AbsPurifier p = new DeepPurifier(AltPurifierType.LINE_MULTILINE, 1);
		c.addPrettifier(++i, p);
		System.out
				.println("TestProg4 mit Copyrightinfo und DeepPurified (mit den Parametern LINE_MULTILINE und 1\n--------------\n"
						+ c.pretty(testProg4));
		Eraser e2 = new Eraser("test", PrettyPos.AFTER);
		c.addPrettifier(++i, e2);
		System.out.println("Programm wie vorher nur mit Eraser mit Parameter 'test' und AFTER\n---------------\n"
				+ c.pretty(testProg4));
		c.removePrettifier(i--);
		AbsPurifier p2 = new AltPurifier(AltPurifierType.LINE);
		c.addPrettifier(++i, p2);
		System.out
				.println("Nun das testProg3 mit Copyright info, Kommentar nach jedem Block, DeepPurifier mit LINE_MULTILINE und 1,\nund abschließendem AltPurifier mit LINE\n----------------------\n"
						+ c.pretty(testProg3));

		// testDeepPurifier(testProg4, AltPurifierType.LINE_MULTILINE, -10000);
		// testPurifier(testProg4);
		// testAltPurifier(testProg3, AltPurifierType.LINE_MULTILINE);
		// testMyEraser();
		// testStripper();
		// testComposer();
		// testPurifiers();
		// testAdders();

	}

	private void testAdders() {
		Adder a = new Adder("Ein neuer Kommentar nach jedem Block:)", PrettyPos.AFTER, "{");
		System.out.println("TestProg1 mit zusaetzlichn Kommentaren nach jedem Block\n----------------------\n"
				+ a.pretty(testProg1));
	}

	private void testMyEraser() {
		System.out.println("Erase Kommentar NACH pattern 'func': ");
		System.out.println("====================================\n");
		testStripperEraser(new Eraser("func", PrettyPos.AFTER));

		System.out.println("Erase Kommentar VOR pattern 'func': ");
		System.out.println("====================================\n");
		testStripperEraser(new Eraser("func", PrettyPos.BEFORE));
		//
		// System.out.println("Erase Kommentar NACH NICHTEXISTENTEN pattern 'XXX': ");
		// System.out.println("====================================\n");
		// testStripperEraser(new Eraser("XXX", PrettyPos.AFTER));
		//
		// System.out.println("Erase Kommentar VOR NICHTEXISTENTEN pattern 'XXX': ");
		// System.out.println("====================================\n");
		// testStripperEraser(new Eraser("XXX", PrettyPos.BEFORE));

		// System.out.println("==========================\n");
		// testStripperEraser(new Eraser("", PrettyPos.BEGIN));
		//
		// System.out.println("Erase Kommentar am Ende: ");
		// System.out.println("==========================\n");
		// testStripperEraser(new Eraser("", PrettyPos.END));
	}

	private void testEraser() {
		System.out.println("Eraser-Tests");
		System.out.println("============\n");

		System.out.println("Erase Kommentar am Anfang: ");
		System.out.println("==========================\n");
		testStripperEraser(new Eraser("", PrettyPos.BEGIN));
		System.out.println("Erase Kommentar am Ende: ");
		System.out.println("========================\n");
		testStripperEraser(new Eraser("", PrettyPos.END));
		System.out.println("Erase Kommentar VOR jeder 'func': ");
		System.out.println("================================\n");
		testStripperEraser(new Eraser("func", PrettyPos.BEFORE));
		System.out.println("Erase Kommentar NACH jeder 'func' : ");
		System.out.println("==================================\n");
		testStripperEraser(new Eraser("func", PrettyPos.AFTER));
	}

	private void testStripper() {
		System.out.println("Stripper-Tests");
		System.out.println("==============\n");

		System.out.println("All comments removed ");
		testStripperEraser(new Stripper());
	}

	private void testStripperEraser(Eraser e) {
		System.out.println("Program 1: ");
		System.out.println(e.pretty(testProg1));
		System.out.println("Program 2: ");
		System.out.println(e.pretty(testProg2));
		System.out.println("Program 3: ");
		System.out.println(e.pretty(testProg3));
	}

	/**
	 * simple basic composer-test
	 */
	private void testComposer() {
		System.out.println("Composer-Tests");
		System.out.println("==============\n");

		Composer c = new Composer();
		// c.addPrettifier(17, new Adder());
		c.addPrettifier(11, new Copyrighter());
		// c.addPrettifier(-1, new Adder());
		// c.addPrettifier(11, new Eraser()); // replaces Copyrighter
		c.removePrettifier(17); // removes Adder
		c.pretty("");
	}

	private void testPurifiers() {
		AbsPurifier p = new Purifier();
		System.out.println("AUFRUF VON Purifier.pretty(testProg2)\n");
		testAbsPurifier(p, testProg2);
		System.out.println(BAR);
		p = new AltPurifier(AltPurifierType.LINE_MULTILINE);
		System.out.println("AUFRUF VON AltPurifier.pretty(testProg4) MIT type=LINE_MULTILINE\n");
		testAbsPurifier(p, testProg4);
		System.out.println(BAR);
		p = new DeepPurifier(AltPurifierType.LINE, -2);
		System.out.println("AUFRUF VON DeepPurifier.pretty(testProg4) MIT type=LINE UND dif=-2\n");
		testAbsPurifier(p, testProg4);
		System.out.println(BAR);
	}

	private void testAbsPurifier(AbsPurifier p, String prog) {
		System.out.println(p.pretty(prog));
	}

	public static void main(String[] args) {
		new Test().run();
	}
}
